************** Quality of Life in Hand Eczema Questionnaire ******* QOLHEQ ********************************;
*;
* The variables have to be named according to their ordering in the questionaire as "qol1", "qol2" to "qol30".;
*;
* The coding for all variables has to be 
"0" for "never", 
"1" for "rarely",
"2" for "sometimes",
"3" for "often" and 
"4" for "all the time";
*;
* After running this script you receive four variables for the domain scores named
"symptoms",
"emotions", 
"functions", 
"treatment";
* and one variable for the overall score named "QOLHEQ";

/*
libname heq "???????????";
data QOLHEQ_1;
     set heq.??????????????????????????;
run;
*/

proc sort data = QOLHEQ_1 (keep =  zentrum  id
			qol1  qol2  qol3  qol4  qol5  qol6  qol7  qol8  qol9  qol10
			qol11 qol12 qol13 qol14 qol15 qol16 qol17 qol18 qol19 qol20
			qol21 qol22 qol23 qol24 qol25 qol26 qol27 qol28 qol29 qol30)
    out =QOLHEQ_2; 
	by zentrum  id;
run;

data QOLHEQ_3;
	set QOLHEQ_2 (keep =  zentrum  id
			qol1  qol2  qol3  qol4  qol5  qol6  qol7  qol8  qol9  qol10
			qol11 qol12 qol13 qol14 qol15 qol16 qol17 qol18 qol19 qol20
			qol21 qol22 qol23 qol24 qol25 qol26 qol27 qol28 qol29 qol30);
	by zentrum  id;
	array org {30}		
		    qol1  qol2  qol3  qol4  qol5  qol6  qol7  qol8  qol9  qol10
			qol11 qol12 qol13 qol14 qol15 qol16 qol17 qol18 qol19 qol20
			qol21 qol22 qol23 qol24 qol25 qol26 qol27 qol28 qol29 qol30 ;
	array new {30}		
		    n_qol1  n_qol2  n_qol3  n_qol4  n_qol5  n_qol6  n_qol7  n_qol8  n_qol9  n_qol10
			n_qol11 n_qol12 n_qol13 n_qol14 n_qol15 n_qol16 n_qol17 n_qol18 n_qol19 n_qol20
			n_qol21 n_qol22 n_qol23 n_qol24 n_qol25 n_qol26 n_qol27 n_qol28 n_qol29 n_qol30 ;

	 do  i= 1 to 30;
  		if org{i} = . then new{i} = 0;
  		else new{i} = org{i};
	 end;

	if n_qol28 = 2 then n_qol28=1;
	   else if n_qol28 = 3 then n_qol28=2;
	   else if n_qol28 = 4 then n_qol28=3;
	   else n_qol28= n_qol28;

	if n_qol10 = 2 then n_qol10=1;
	   else if n_qol10 = 3 then n_qol10=2;
	   else if n_qol10 = 4 then n_qol10=3;
	   else n_qol10= n_qol10;

	if n_qol4 = 2 then n_qol4=1;
	   else if n_qol4 = 3 then n_qol4=2;
	   else if n_qol4 = 4 then n_qol4=3;
	   else n_qol4= n_qol4;

/* Symptoms*/
  nmis_org_symptoms =   nmiss(  qol1 ,   qol6 ,  qol9 ,   qol11 ,   qol20 ,   qol23 ,   qol28); 
           symptoms =     sum(n_qol1 , n_qol6 ,n_qol9 , n_qol11 , n_qol20 , n_qol23 , n_qol28);
	if nmis_org_symptoms > 1 then symptoms=.;

/* emotions*/
  nmis_org_emotions = nmiss(    qol5,    qol8,     qol10 ,   qol16,   qol19, 
                               qol21,   qol27,     qol30);
           emotions =   sum(  n_qol5,  n_qol8,   n_qol10 , n_qol16, n_qol19, 
                             n_qol21, n_qol27,   n_qol30);
	if nmis_org_emotions > 1 then emotions=.;

/* functioning*/
  nmis_org_functions = nmiss(      qol2,    qol3,   qol12,   qol14,   qol15,   qol17,
                                 qol25,   qol29); 
           functions =   sum(    n_qol2,  n_qol3, n_qol12, n_qol14, n_qol15, n_qol17,
                               n_qol25, n_qol29);
	if nmis_org_functions > 1 then functions=.;

/* Treatment*/
 nmis_org_Treatment =  nmiss(    qol4,     qol7,    qol13 ,   qol18,   
                                qol22,    qol24,    qol26); 
           Treatment=  sum(    n_qol4,   n_qol7,  n_qol13 , n_qol18, 
                              n_qol22,  n_qol24,  n_qol26);
	if nmis_org_Treatment > 1 then Treatment=.;

/* QOLHEQ*/
		nmis_org_all = nmiss(	
			     qol1,  qol2,  qol3,  qol4,  qol5,  qol6,  qol7,  qol8,  qol9, qol10,
				qol11, qol12, qol13, qol14, qol15, qol16, qol17, qol18, qol19, qol20,
				qol21, qol22, qol23, qol24, qol25, qol26, qol27, qol28, qol29, qol30);
		QOLHEQ 		= sum(
		     n_qol1,  n_qol2,  n_qol3,  n_qol4,  n_qol5,  n_qol6,  n_qol7,  n_qol8,  n_qol9, n_qol10,
			n_qol11, n_qol12, n_qol13, n_qol14, n_qol15, n_qol16, n_qol17, n_qol18, n_qol19, n_qol20,
			n_qol21, n_qol22, n_qol23, n_qol24, n_qol25, n_qol26, n_qol27, n_qol28, n_qol29, n_qol30) ;
	if nmis_org_all > 3  then QOLHEQ=.;

	Label 
	  nmis_org_symptoms="n missings in symptoms"
      	symptoms="symptoms"
	  nmis_org_emotions="n missings in emotions"
      	emotions="emotions"
	  nmis_org_functions="n missings in functions"
      	functions="functions"
	  nmis_org_Treatment="n missings in treatment"
      	Treatment="treatment and prevention"
	  nmis_org_all="n missings all over the items"
      	QOLHEQ="QOLHEQ overall score";
run;



